#ifndef RT_GFX_BUILTIN_OBJECTS_H
#define RT_GFX_BUILTIN_OBJECTS_H

/* Render Object types used by the builtin graphics passes.
 *
 * As an user you are free to not use these, but then you
 * also cannot use the builtin render passes. */

#include "renderer_api.h"
#include "render_list.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    rt_buffer_handle vbo;
    rt_buffer_handle ibo;
    uint32_t vertex_count;
    uint32_t index_count;
} rt_render_mesh;



typedef struct {
    rt_render_object_type render_mesh;
} rt_builtin_render_object_types;

#ifndef RT_DONT_DEFINE_BULTIN_OBJECTS_GLOBAL
extern RT_DLLIMPORT rt_builtin_render_object_types g_builtin_render_object_types;
#endif

RT_DLLEXPORT rt_result rtRegisterBuiltinRenderObjectTypes(void);

#ifdef __cplusplus
}
#endif

#endif
